Attribute VB_Name = "mMath"
Option Explicit
Public CoxaLength As Single
Public FemurLength As Single
Public TibiaLength As Single
Public TorsoLength As Single
Public TailLength As Single
Public Const CoxaLengthReel As Single = 2
Public Const FemurLengthReel As Single = 5.6
Public Const TibiaLengthReel As Single = 4.2
Public Const PI As Double = 3.14159265358979
Public Const Rad# = 57.2957795130823
Public Const PiRad# = 1.74532925199433E-02


        
Public Function aTan2(y As Double, x As Double) As Double
If x > 0 Then
        aTan2 = Atn(y / x)
    ElseIf x < 0 Then
        aTan2 = Sgn(y) * (PI - Atn(Abs(y / x)))
    ElseIf y = 0 Then
        aTan2 = 0
    Else
        aTan2 = Sgn(y) * PI / 2
End If
End Function
Function ASin(a As Double) As Double
ASin = (a / Sqr(a * a + 1))
ASin = (90 * PI / 180) - ASin
End Function
Function ACos(a As Double) As Double
 On Error Resume Next
 If Abs(a) <> 1 Then
        ACos = 1.5707963267949 - Atn(a / Sqr(1 - (a * a)))
    ElseIf a = -1 Then
        ACos = 3.14159265358979
    End If

End Function

